qpid::sys Namespace Reference

Apache Qpid - AMQP Messaging for Java JMS, C++, Python, Ruby, and .NET | Apache Qpid Documentation

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Namespace List
- Namespace Members

Namespaces | Classes | Typedefs | Functions | Variables
qpid::sys Namespace Reference

## Namespaces
namespace | SystemInfo
| Retrieve information about the system we are running on.
## Classes
struct | Raisable
class | ExceptionHolder
| Holder for exceptions. More...
class | IOHandle
class | Monitor
| A monitor is a condition variable and a mutex. More...
class | ScopedLock
| Scoped lock template: calls lock() in ctor, unlock() in dtor. More...
class | ScopedUnlock
class | ScopedRlock
class | ScopedWlock
class | ConditionalScopedLock
class | Condition
| A condition variable for thread synchronization. More...
class | Mutex
| Mutex lock. More...
class | RWlock
| RW lock. More...
struct | PODMutex
| PODMutex is a POD, can be static-initialized with PODMutex m = QPID_PODMUTEX_INITIALIZER. More...
class | IOHandlePrivate
class | PosixIOHandle
class | NullIOHandle
class | Runnable
| Interface for objects that can be run, e.g. More...
class | Thread
class | AbsTime
| Class to represent an instant in time. More...
class | Duration
| Class to represent the duration between instants of time. More...
## Typedefs
typedef int64_t | TimePrivate
| Class to represent an instant in time.
## Functions
struct timespec & | toTimespec (struct timespec &ts, const Duration &t)
struct timeval & | toTimeval (struct timeval &tv, const Duration &t)
Duration | toTime (const struct timespec &ts)
struct addrinfo & | getAddrInfo (const SocketAddress &)
int | toFd (const IOHandlePrivate *h)
std::string | strError (int err)
| Get the error message for a system number err, e.g.
std::ostream & | operator<< (std::ostream &, const AbsTime &)
std::ostream & | operator<< (std::ostream &, const Duration &)
AbsTime | now ()
bool | operator< (const AbsTime &a, const AbsTime &b)
bool | operator> (const AbsTime &a, const AbsTime &b)
void | sleep (int secs)
| Portable sleep for a number of seconds.
void | usleep (uint64_t usecs)
| Portable sleep for a number of microseconds.
void | outputFormattedNow (std::ostream &)
| Output formatted date/time for now.
void | outputHiresNow (std::ostream &)
| Output unformatted nanosecond-resolution time for now.
## Variables
NullIOHandle | DummyIOHandle
const Duration | TIME_SEC = 1000*1000*1000
| Nanoseconds per second.
const Duration | TIME_MSEC = 1000*1000
| Nanoseconds per millisecond.
const Duration | TIME_USEC = 1000
| Nanoseconds per microseconds.
const Duration | TIME_NSEC = 1
| Nanoseconds per nanosecond.
const Duration | TIME_INFINITE = std::numeric_limits<int64_t>::max()
| Value to represent an infinite timeout.
const AbsTime | EPOCH = AbsTime::Epoch()
| Absolute time point for the Unix epoch: 1970-01-01T00:00:00.
const AbsTime | FAR_FUTURE = AbsTime::FarFuture()
| Time greater than any other time.

## Typedef Documentation

typedef boost::posix_time::ptime qpid::sys::TimePrivate

Class to represent an instant in time.

Boost has this stuff already done so just reuse it. We can also grab this for quick use with the Condition wait operations.

Definition at line 30 of file Time.h.

## Function Documentation

struct addrinfo& qpid::sys::getAddrInfo | ( | const SocketAddress & |  | ) | `[read]`

AbsTime qpid::sys::now | ( |  | ) | `[inline]`

Definition at line 129 of file Time.h.

References qpid::sys::AbsTime::now().

bool qpid::sys::operator< | ( | const AbsTime & | a,
|  | const AbsTime & | b
| ) |  | `[inline]`

Definition at line 131 of file Time.h.

std::ostream& qpid::sys::operator<< | ( | std::ostream & | ,
|  | const AbsTime & |
| ) |  |

std::ostream& qpid::sys::operator<< | ( | std::ostream & | ,
|  | const Duration & |
| ) |  |

bool qpid::sys::operator> | ( | const AbsTime & | a,
|  | const AbsTime & | b
| ) |  | `[inline]`

Definition at line 133 of file Time.h.

void qpid::sys::outputFormattedNow | ( | std::ostream & |  | ) |

Output formatted date/time for now.

void qpid::sys::outputHiresNow | ( | std::ostream & |  | ) |

Output unformatted nanosecond-resolution time for now.

void qpid::sys::sleep | ( | int | secs | ) |

Portable sleep for a number of seconds.

std::string qpid::sys::strError | ( | int | err | ) |

Get the error message for a system number err, e.g.

errno.

int qpid::sys::toFd | ( | const IOHandlePrivate * | h | ) |

Duration qpid::sys::toTime | ( | const struct timespec & | ts | ) |

struct timespec& qpid::sys::toTimespec | ( | struct timespec & | ts,
|  | const Duration & | t
| ) |  | `[read]`

Referenced by qpid::sys::Condition::wait().

struct timeval& qpid::sys::toTimeval | ( | struct timeval & | tv,
|  | const Duration & | t
| ) |  | `[read]`

void qpid::sys::usleep | ( | uint64_t | usecs | ) |

Portable sleep for a number of microseconds.

## Variable Documentation

NullIOHandle qpid::sys::DummyIOHandle

const AbsTime qpid::sys::EPOCH = AbsTime::Epoch()

Absolute time point for the Unix epoch: 1970-01-01T00:00:00.

Definition at line 156 of file Time.h.

Referenced by qpid::sys::Condition::wait().

const AbsTime qpid::sys::FAR_FUTURE = AbsTime::FarFuture()

Time greater than any other time.

Definition at line 159 of file Time.h.

const Duration qpid::sys::TIME_INFINITE = std::numeric_limits<int64_t>::max()

Value to represent an infinite timeout.

Definition at line 153 of file Time.h.

const Duration qpid::sys::TIME_MSEC = 1000*1000

Nanoseconds per millisecond.

Definition at line 146 of file Time.h.

const Duration qpid::sys::TIME_NSEC = 1

Nanoseconds per nanosecond.

Definition at line 150 of file Time.h.

const Duration qpid::sys::TIME_SEC = 1000*1000*1000

Nanoseconds per second.

Definition at line 144 of file Time.h.

const Duration qpid::sys::TIME_USEC = 1000

Nanoseconds per microseconds.

Definition at line 148 of file Time.h.